-- represents the walls, floors and platforms of the level

local Entity = require 'entities.Entity'

local Block = class('Block', Entity)

function Block:initialize(l,t,w,h,x,s)
  Entity.initialize(self, l,t,w,h)
  if x and x=="lava" then self.type="lava" end
  if x and x=="slick" then self.type="slick" end
  if s then self.static = true end
end

function Block:change()
  local changefac = math.random(5)
  if changefac==1 then
    self.type = "lava"
  elseif changefac==5 then
    self.type = "slick"
  else
    self.type = false
  end
end

function Entity:draw()
  -- old: 220,150,150
  if self.type=="lava" then
  love.graphics.setColor(250,50,50,100)
  elseif self.type=="slick" then
  -- love.graphics.setColor(150,150,50,100)
  love.graphics.setColor(250,250,250,100)
  else
  love.graphics.setColor(0,150,150,100)
  end
  love.graphics.rectangle('fill', self:getBBox())
  love.graphics.setColor(0,150,150)
  love.graphics.rectangle('line', self:getBBox())
end

function Block:shouldCollide(other)
  return false
end

return Block
