local bump = require 'lib.bump'

local entities = {} -- this will hold the list of entities

local Entity = class('Entity')

local function copy(t)
  local c = {}
  for k,v in pairs(t) do c[k] = v end
  return c
end

function Entity:initialize(l,t,w,h)
  self.l, self.t, self.w, self.h = l,t,w,h
  entities[self] = true
  bump.add(self)
end

function Entity:destroy()
  bump.remove(self)
  entities[self] = nil
end

function Entity:update()
end

function Entity:retrieve(this)
  return entities[this] ~= nil
end

function Entity:collision(other, dx, dy)
end

function Entity:endCollision(other)
end

function Entity:shouldCollide(other)
  return true
end

function Entity:getBBox()
  return self.l, self.t, self.w, self.h
end

function Entity:getCenter()
  return self.l + self.w/2, self.t + self.h/2
end

function Entity:getFeet()
  return self.l + self.w/2, self.t + self.h
end

function Entity.static:destroyAll()
  for entity,_ in pairs(copy(entities)) do
    entity:destroy()
  end
end

return Entity
