local map = {}

local width = 7680
local height = 4320
-- local width = 1080
-- local height = 30720
-- local width = 1024
-- local height = 32768
-- local height = 1080
-- local width = 30720
-- 33955200 px

local Entity     = require 'entities.Entity'
local Block      = require 'entities.Block'
local Monster    = require 'entities.Monster'
local Object     = require 'entities.Object'

local random = math.random

function selectMapNormal()
  local tilesOnFloor = 32
  local blockCount = 64
  local width=7680
  local height=4320
    Block:new(32,3240,width-960,32,"slick",true)
    Block:new(960,2160,width-960,32,"slick",true)
    Block:new(32,1080,width-960,32,"slick",true)
end

function map.reset(t,l)
  map.lvlup = false
  if l then
    map.level = l
  else
    map.level = 1
  end
  Entity:destroyAll()
  gameType=t
  local tilesOnFloor = 32
  local blockCount = 64
  if t=="x" then
    selectMapNormal()
  end
  if t=="c" then
    blockCount=384
    tilesOnFloor = 8
    width=1920
    -- height=17685
    height=16384
  end
  if t=="v" then
    blockCount=384
    tilesOnFloor = 256
    width=34560
    -- width=31440
    height=1080
  end
  if t=="m" then
    blockCount=24
    tilesOnFloor=8
    width=1920
    height=1080
  end
  if t=="b" then
    width=7680
    height=4320
  end

  -- Entity:destroyAll()
  -- walls & ceiling
  if t=="c" then                        --  no ceiling in the climb
  else
    Block:new(0,0,width,32,"slick",true)     --  no grappling the ceiling
  end
  Block:new(0,0,32,height,"slick",true)          --  left wall
  Block:new(width-32,0,32,height,"slick",true)   --  right wall
  -- tiled floor
  Block:new(0,height-32,width/tilesOnFloor,32,false,true)
  if t=="c" then
    Block:new(width - width/tilesOnFloor,height-32,width/tilesOnFloor,32,false,true)
  end
  for i=1,tilesOnFloor - 1 do
    if t=="v" then                      --  lava mode floor hazard
    Block:new(i*width/tilesOnFloor, height-32, width/tilesOnFloor, 32,"lava",true)
    elseif t=="c" then                  --  no floor in the climb
    else
    Block:new(i*width/tilesOnFloor, height-32, width/tilesOnFloor, 32,false,true)
    end
  end

  -- procedural blocks
  for i=1,blockCount do
    randtype = random(5)
    if randtype==1 then
      btype = "lava"
    elseif randtype==5 then
      btype = "slick"
    else
      btype = false
    end
    if t=="c" or t=="v" then
      Block:new(random(100,width-200),random(100,height-150),random(32,100),random(32,100),btype)
    else
      Block:new(random(32,width-32),random(100,960),random(32,100),random(32,100),btype)
      Block:new(random(32,width-32),random(1180,2040),random(32,100),random(32,100),btype)
      Block:new(random(32,width-32),random(2260, 3120), random(32,100), random(32,100),btype)
      Block:new(random(32,width-32), random(3340,4200), random(32,100), random(32,100),btype)
    end
  end

  -- procedural monsters
  boss=map.level*10
  if t=="b" then                        --  blank, no monsters
  elseif t=="v" then			--  lava, fewer monsters
    Object:new(width-100,height-100,"maptoken")
    -- Object:new(200,height-100,"maptoken")
    Object:new(100,height-100,"omakase")
  elseif t=="m" then                    --  death match, one very strong monster
    Monster:new(random(100,width-200),random(100,height-200),random(-50,50),random(-50,50),boss,true)
  else                                  --  all other modes
    Monster:new(random(100,width-200),random(100,height-200),random(-50,50),random(-50,50),boss,true)
    for i=1,100 do
      Monster:new(random(100,width-200),random(100,height-200),random(-50,50),random(-50,50),map.level)
    end
  end
  map.width = width
  map.height = height
  
  -- special stuff

end

map.width = width
map.height = height

return map
