local menu = {}

local mCommands = {"Commands:",
  "S = Move Left",
  "F = Move Right",
  "D = Down",
  "E = Up",
  "J = Jump",
  "K = Attack",
  "L = Grapple",
  "I = Special",
  "Shift = Pause",
  "Return = Reset Map"}

local mGameselect = {"Select Game Type:",
  "B - Blank Board: standard practice zone with no enemies",
  "X - Normal Game: standard zone with enemies",
  "C - The Climb: endless vertical zone",
  "V - Lava: horizontal zone with floor hazard",
  "M - Death Match: small zone and one powerful enemy"}

local mInstructions = {"Game Instructions:",
  "You can launch your grapple only while in mid-air.",
  "Normal blocks allow you to both stand on and attach your grapple to them.",
  "Gray blocks allow you to stand on them but cannot hold your grapple.",
  "Red blocks can be grappled, but don't stand on them or you will take damage.",
  "Use Up and Down to retract or extend your grapple line while swinging.",
  "Use Left and Right to swing from your grapple line.",
  "Perform a dive-kick by holding Down and pressing Jump in mid-air.",
  "Use directions and Special to perform different special attacks.",
  "Defeated enemies sometimes drop food which recovers Life and Power.",
  "Pick up food to power up your attacks for a short time.",
  "Perform unlimited Special attacks while powered up.",
  "There are five Elements, represented by the letters P, E, W, F and M.",
  "Each Element is strong against two other elements and weak against the remaining two.",
  "Activate an Element attack by pressing a number key 1-5.",
  "Deactivate Element attacks by pressing 0."}

local ytext=0 

function menu:title()                   --  title menu
  ytext = 110
  for c=1,#mCommands do
    love.graphics.print(mCommands[c],210,ytext)
    ytext = ytext + 15
  end
  ytext = 110
  for c=1,#mGameselect do
    love.graphics.print(mGameselect[c],410,ytext)
    ytext = ytext + 15
  end
  ytext = 290
  for c=1,#mInstructions do
    love.graphics.print(mInstructions[c],210,ytext)
    ytext = ytext + 15
  end
end

function menu:pause()                   --  pause menu
  love.graphics.setColor(255,0,0)
  love.graphics.setFont(bigFont)
  love.graphics.print("PAUSED",480,120)
  love.graphics.setFont(defaultFont)
  love.graphics.setColor(255,255,255)
  ytext = 110
  for c=1,#mCommands do
    love.graphics.print(mCommands[c],210,ytext)
    ytext = ytext + 15
  end
  ytext = 290
  for c=1,#mInstructions do
    love.graphics.print(mInstructions[c],210,ytext)
    ytext = ytext + 15
  end
end

function menu:draw(state)
  self.state=state
  love.graphics.setColor(255,255,255)
  love.graphics.rectangle('line',200,100,700,500)
  if self.state=="pause" then
    self:pause()
  elseif self.state=="start" then
    self:title()
  end
end

function menu:update()
  
end

return menu
